//+------------------------------------------------------------------+

#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 9
#property indicator_color1  Red
#property indicator_color2  Blue
#property indicator_color3  Green
#property indicator_style3  STYLE_DOT
#property indicator_color4  Brown
#property indicator_style4  STYLE_DOT
#property indicator_color5  LimeGreen
#property indicator_color6  PaleVioletRed
#property indicator_color7  PaleVioletRed
#property indicator_color8  Green
#property indicator_style8  STYLE_DOT
#property indicator_color9  Brown
#property indicator_style9  STYLE_DOT

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    Tenkan       = 9;
extern int    Kijun        = 26;
extern int    Senkou       = 52;
extern bool   LinesVisible = true;
extern int    LinesNumber  = 10;
extern color  ColorUp      = LimeGreen;
extern color  ColorDown    = PaleVioletRed;
extern string UniqueID     = "ChinkouLines1";
extern bool   Draw_Tenkan  = false;
extern bool   Draw_Kijun   = false;
extern bool   Draw_Kumo    = false;
extern bool   Draw_Chikou  = true;

//
//
//
//
//

double Tenkan_Buffer[];
double Kijun_Buffer[];
double SpanA[];
double SpanB[];
double Chinkou[];
double ChinkouDa[];
double ChinkouDb[];
double SpanA2[];
double SpanB2[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//
//
//
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(10);
   SetIndexBuffer(0,Tenkan_Buffer);                           SetIndexLabel(0,"Tenkan Sen");
   SetIndexBuffer(1,Kijun_Buffer);                            SetIndexLabel(1,"Kijun Sen");
   SetIndexBuffer(2,SpanA);  SetIndexStyle(2,DRAW_HISTOGRAM);  
   SetIndexBuffer(3,SpanB);  SetIndexStyle(3,DRAW_HISTOGRAM);  
   SetIndexBuffer(4,Chinkou);                                 SetIndexLabel(4,"Chinkou Span");
   SetIndexBuffer(5,ChinkouDa);                               SetIndexLabel(5,"Chinkou Span");
   SetIndexBuffer(6,ChinkouDb);                               SetIndexLabel(6,"Chinkou Span");
   SetIndexBuffer(7,SpanA2);                                  SetIndexLabel(7,"Senkou Span A");
   SetIndexBuffer(8,SpanB2);                                  SetIndexLabel(8,"Senkou Span B");
   SetIndexBuffer(9,trend);
   if (!Draw_Tenkan) SetIndexStyle(0, DRAW_NONE); else SetIndexStyle(0, DRAW_LINE);
   if (!Draw_Kijun)  SetIndexStyle(1, DRAW_NONE); else SetIndexStyle(1, DRAW_LINE);
   if (!Draw_Chikou) 
   { 
      SetIndexStyle(4, DRAW_NONE);
      SetIndexStyle(5, DRAW_NONE);
      SetIndexStyle(6, DRAW_NONE);
   } 
   else 
   {
      SetIndexStyle(4, DRAW_LINE);
      SetIndexStyle(5, DRAW_LINE);
      SetIndexStyle(6, DRAW_LINE);
   }
   if (!Draw_Kumo) 
   {
      SetIndexStyle(2, DRAW_NONE);
      SetIndexStyle(3, DRAW_NONE);
      SetIndexStyle(7, DRAW_NONE);
      SetIndexStyle(8, DRAW_NONE);
   }
   else
   {
      SetIndexStyle(2, DRAW_HISTOGRAM);
      SetIndexStyle(3, DRAW_HISTOGRAM);
      SetIndexStyle(7, DRAW_LINE);
      SetIndexStyle(8, DRAW_LINE);
   }   
   
      //
      //
      //
      //
      //
     
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
     
      SetIndexShift(2,Kijun  * timeFrame/Period()); 
      SetIndexShift(3,Kijun  * timeFrame/Period());
      SetIndexShift(4,-Kijun * timeFrame/Period()); 
      SetIndexShift(5,-Kijun * timeFrame/Period());
      SetIndexShift(6,-Kijun * timeFrame/Period());
      SetIndexShift(7,Kijun  * timeFrame/Period());
      SetIndexShift(8,Kijun  * timeFrame/Period());   
     
      //
      //
      //
      //
      //
     
      IndicatorShortName(timeFrameToString(timeFrame)+"  Ichimoku");  
return(0);
}

void deinit()
{
   deleteLines();
}
void deleteLines()
{
   int lookForLength = StringLen(UniqueID);
   for (int i= ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
      if (StringSubstr(name,0,lookForLength)==UniqueID) ObjectDelete(name);
   }
}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;
   
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { Tenkan_Buffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     if (trend[limit]==-1) CleanPoint(limit,ChinkouDa,ChinkouDb);
     for(i=limit; i>=0; i--)
     {
        double thi    = High[i];
        double tlo    = Low[i];
        double tprice = 0;
        if (i >= Bars - Tenkan) continue;
        for(k = 0; k < Tenkan; k++)
        {
           tprice = High[i+k];
           if(thi < tprice)  thi = tprice;
         
           tprice = Low[i+k];
           if(tlo  > tprice) tlo = tprice;
        }
       
        if ((thi+tlo) > 0.0) 
             Tenkan_Buffer[i] = (thi + tlo)/2; 
        else Tenkan_Buffer[i] = 0;
       
        //
        //
        //
        //
        //
        
        double khi    = High[i];
        double klo    = Low[i];
        double kprice = 0;
        if  (i >= Bars - Kijun) continue;
        for (k = 0; k < Kijun; k++)
        {
           kprice = High[i+k];
           if(khi < kprice)  khi  = kprice;
         
           kprice = Low[i+k];
           if(klo  > kprice) klo  = kprice;
        }
        
        if ((khi+klo) > 0.0) 
             Kijun_Buffer[i] = (khi + klo)/2; 
        else Kijun_Buffer[i] = 0;
       
        //
        //
        //
        //
        //
        
        double shi    = High[i];
        double slo    = Low[i];
        double sprice = 0;
        if  (i >= Bars - Senkou) continue;
        for (k = 0; k < Senkou; k++)
        {
           sprice = High[i+k];
           if(shi < sprice)  shi  = sprice;
         
           sprice = Low[i+k];
           if(slo  > sprice) slo  = sprice;
        }
       
        //
        //
        //
        //
        //
        
        SpanA[i]   = (Kijun_Buffer[i] + Tenkan_Buffer[i])/2;
        SpanA2[i]  = (Kijun_Buffer[i] + Tenkan_Buffer[i])/2;
        SpanB[i]   = (shi + slo)/2; 
        SpanB2[i]  = (shi + slo)/2; 
        Chinkou[i] = Close[i];
        
        //
        //
        //
        //
        //
        
        ChinkouDa[i] = EMPTY_VALUE;
        ChinkouDb[i] = EMPTY_VALUE;
        trend[i] = trend[i+1];
          if (Chinkou[i]>Chinkou[i+1]) trend[i] =  1;
          if (Chinkou[i]<Chinkou[i+1]) trend[i] = -1;
          if (trend[i] == -1) PlotPoint(i,ChinkouDa,ChinkouDb,Chinkou); 
        
   
    }
    deleteLines();
         if (LinesVisible)
         {
            int j = 0;
            for (i=0; i<Bars && j<LinesNumber; i++)
            if (trend[i]!=trend[i+1])
               {
                  string name = UniqueID+(string)Time[i+Kijun];
                  ObjectCreate(name,OBJ_TREND,0,Time[i+Kijun],Chinkou[i],Time[i+Kijun]+Period()*60,Chinkou[i]);
                     if (trend[i]==1)
                           ObjectSet(name,OBJPROP_COLOR,ColorUp);
                     else  ObjectSet(name,OBJPROP_COLOR,ColorDown);                   
                     j++;
               }
        }
  return(0);
  }
  
  //
  //
  //
  //
  //
   
  limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
  if (trend[limit]==-1) CleanPoint(limit,ChinkouDa,ChinkouDb);
  for (i=limit;i>=0;i--)
  {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Tenkan_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,LinesVisible,LinesNumber,ColorUp,ColorDown,UniqueID,0,y);
         Kijun_Buffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,LinesVisible,LinesNumber,ColorUp,ColorDown,UniqueID,1,y);
         SpanA[i]         = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,LinesVisible,LinesNumber,ColorUp,ColorDown,UniqueID,2,y);
         SpanB[i]         = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,LinesVisible,LinesNumber,ColorUp,ColorDown,UniqueID,3,y);
         Chinkou[i]       = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,LinesVisible,LinesNumber,ColorUp,ColorDown,UniqueID,4,y);
         ChinkouDa[i]     = EMPTY_VALUE;
         ChinkouDb[i]     = EMPTY_VALUE;
         SpanA2[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,LinesVisible,LinesNumber,ColorUp,ColorDown,UniqueID,7,y);
         SpanB2[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,LinesVisible,LinesNumber,ColorUp,ColorDown,UniqueID,8,y);  
         trend[i]         = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,LinesVisible,LinesNumber,ColorUp,ColorDown,UniqueID,9,y); 
         trend[i] = trend[i+1];
         if (Chinkou[i]>Chinkou[i+1]) trend[i] =  1;
         if (Chinkou[i]<Chinkou[i+1]) trend[i] = -1;
         if (trend[i] == -1) PlotPoint(i,ChinkouDa,ChinkouDb,Chinkou);        
  }
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}



